VERSION 5.00
Begin VB.Form frmAddCustomer 
   Caption         =   "Customer Management"
   ClientHeight    =   4095
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6090
   LinkTopic       =   "Form1"
   ScaleHeight     =   4095
   ScaleWidth      =   6090
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdShowOrders 
      Caption         =   "Show Current Orders"
      Height          =   375
      Left            =   2400
      TabIndex        =   13
      Top             =   2160
      Visible         =   0   'False
      Width           =   1755
   End
   Begin VB.CommandButton cmdUpdateCustomer 
      Caption         =   "Update Record"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4260
      TabIndex        =   12
      Top             =   3000
      Width           =   1755
   End
   Begin VB.TextBox txtCredit 
      BackColor       =   &H00FFFFFF&
      Enabled         =   0   'False
      Height          =   315
      Left            =   1500
      TabIndex        =   11
      Top             =   3120
      Width           =   1395
   End
   Begin VB.TextBox txtPhone 
      Height          =   315
      Left            =   1440
      TabIndex        =   10
      Top             =   420
      Width           =   4455
   End
   Begin VB.TextBox txtAddress 
      Height          =   1215
      Left            =   1440
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   9
      Top             =   780
      Width           =   4455
   End
   Begin VB.TextBox txtCustomer 
      Height          =   315
      Left            =   1440
      TabIndex        =   8
      Top             =   60
      Width           =   4455
   End
   Begin VB.TextBox txtBalance 
      BackColor       =   &H00FFFFFF&
      Enabled         =   0   'False
      Height          =   315
      Left            =   1500
      TabIndex        =   7
      Top             =   2700
      Width           =   1395
   End
   Begin VB.CommandButton cmdDeleteCustomer 
      Caption         =   "Delete Customer"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4260
      TabIndex        =   6
      Top             =   3660
      Width           =   1755
   End
   Begin VB.CommandButton cmdNewCustomer 
      Caption         =   "Add New Customer"
      Height          =   375
      Left            =   4260
      TabIndex        =   3
      Top             =   2160
      Width           =   1755
   End
   Begin VB.Label Label1 
      Caption         =   "Customer Credit"
      Height          =   255
      Index           =   4
      Left            =   0
      TabIndex        =   5
      Top             =   3180
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Customer Balance"
      Height          =   255
      Index           =   3
      Left            =   0
      TabIndex        =   4
      Top             =   2760
      Width           =   1395
   End
   Begin VB.Label Label1 
      Caption         =   "Phone"
      Height          =   255
      Index           =   2
      Left            =   60
      TabIndex        =   2
      Top             =   480
      Width           =   1155
   End
   Begin VB.Label Label1 
      Caption         =   "Billing Address"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   1
      Top             =   840
      Width           =   1275
   End
   Begin VB.Label Label1 
      Caption         =   "Customer Name"
      Height          =   255
      Index           =   0
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   1275
   End
End
Attribute VB_Name = "frmAddCustomer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim rs As New Recordset
Dim currentCustId As Long

Private Sub cmdNewCustomer_Click()
    
    Dim msg As String
    
    If Not VerifyInfo() Then Exit Sub
    
    rs.Open "Insert into tblcustomers (company,BillingAddress,phone) Values('" & _
            safe(txtCustomer) & "','" & safe(txtAddress) & "','" & safe(txtPhone) & "')"
            
    Unload Me
    
End Sub

Private Function VerifyInfo() As Boolean
    Dim msg As String
    
    If Len(safe(txtCustomer)) = 0 Then msg = "Customer Name cannot be Blank"
    If Len(safe(txtPhone)) = 0 Then msg = msg & "Phone Cannot be Blank" & vbCrLf
    If Len(safe(txtAddress)) = 0 Then msg = msg & "Address Cannot be Blank" & vbCrLf
    
    If Len(msg) > 0 Then
        MsgBox msg, vbInformation
        Exit Function
    End If

    VerifyInfo = True
    
End Function
Private Sub cmdShowOrders_Click()
    frmSelectCustomer.ShowOrders currentCustId
End Sub

Private Sub cmdUpdateCustomer_Click()
    
    If Not VerifyInfo() Then Exit Sub
    
    cn.Execute "Update tblCustomers set company='" & safe(txtCustomer) & "'," & _
               "BillingAddress='" & safe(txtAddress) & "'," & _
               "phone='" & safe(txtPhone) & "' " & _
               "where autoid=" & currentCustId
    
End Sub

Private Sub Form_Load()
    rs.ActiveConnection = cn
End Sub


Sub AddCompany()
    
    Me.Height = 3000
    Me.Show 1
    
End Sub

Sub ViewBalance(custId As Long)
    
    currentCustId = custId
    
    SetParent Me.hWnd, frmMain.hWnd
    
   
    Me.Height = 3915
    cmdNewCustomer.Visible = False
    
    rs.Open "Select * from tblCustomers where autoid=" & custId
    
    If rs.EOF And rs.BOF Then
        MsgBox "Oops Customer ID: " & custId & " not found!", vbExclamation
        Exit Sub
    End If
    
    txtCustomer = rs!company
    txtPhone = rs!phone
    txtAddress = rs!BillingAddress
    txtBalance = rs!balanceDue
    txtCredit = rs!credit
    cmdShowOrders.Visible = True
    
    rs.Close
    
    If userGroup <> DataEntry Then
        txtBalance.Enabled = True
        txtCredit.Enabled = True
        cmdUpdateCustomer.Enabled = True
    End If
    
    If userGroup = Administrator Then
        Me.Height = 4545
        cmdDeleteCustomer.Enabled = True
    End If
    
    Me.Show
    
End Sub
