VERSION 5.00
Begin VB.MDIForm frmMain 
   BackColor       =   &H8000000C&
   Caption         =   "XYZ Corporation Account Manager"
   ClientHeight    =   6375
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   9450
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   2  'CenterScreen
   Begin VB.Menu mnuAccount 
      Caption         =   "User"
      Begin VB.Menu mnuLogout 
         Caption         =   "Logout"
      End
      Begin VB.Menu mnuChangeUsers 
         Caption         =   "Login As Another User"
      End
   End
   Begin VB.Menu mnuOrders 
      Caption         =   "Orders"
      Begin VB.Menu mnuNewOrder 
         Caption         =   "Enter New Order"
      End
      Begin VB.Menu mnuSearchOrders 
         Caption         =   "Search Orders"
      End
   End
   Begin VB.Menu mnuCustomers 
      Caption         =   "Customers"
      Begin VB.Menu mnuNewCustomer 
         Caption         =   "New Customer"
      End
      Begin VB.Menu mnuCustomerBalance 
         Caption         =   "Customer Balance"
      End
      Begin VB.Menu mnuCustomerOrders 
         Caption         =   "Customer Orders"
      End
   End
   Begin VB.Menu mnuAccoutnsReceivable 
      Caption         =   "Accounts Receivable"
      Begin VB.Menu mnuPaymentReceived 
         Caption         =   "Payment Received"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuUpdateCustomerAccount 
         Caption         =   "Update Customer Account"
         Enabled         =   0   'False
      End
   End
   Begin VB.Menu mnuAdmin 
      Caption         =   "Administration"
      Begin VB.Menu mnuAddNewUser 
         Caption         =   "New User"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuManageUsers 
         Caption         =   "Manage Users"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuProductAdmin 
         Caption         =   "Product Administration"
         Enabled         =   0   'False
      End
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "About"
      Begin VB.Menu mnuAuthor 
         Caption         =   "Author"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit


Private Sub MDIForm_Load()
    On Error Resume Next
    
    If userGroup <> DataEntry Then
        mnuPaymentReceived.Enabled = True
        mnuUpdateCustomerAccount.Enabled = True
    End If
    
    If userGroup = Administrator Then
        mnuAddNewUser.Enabled = True
        mnuManageUsers.Enabled = True
        mnuProductAdmin.Enabled = True
    End If
    
'    mnuAuthor.Enabled = False
    
End Sub

Private Sub mnuAddNewUser_Click()
    frmManageUsers.AddnewUser
End Sub

Private Sub mnuAuthor_Click()
    frmAbout.Show 1
End Sub

Private Sub mnuChangeUsers_Click()
    ReLogin
End Sub

Private Sub mnuCustomerBalance_Click()
    frmSelectCustomer.SelectCompany
    If SelectedCompany = 0 Then Exit Sub
    frmAddCustomer.ViewBalance SelectedCompany
End Sub

Private Sub mnuCustomerOrders_Click()
    frmSelectCustomer.SelectCompany
    If SelectedCompany = 0 Then Exit Sub
    frmSelectCustomer.ShowOrders SelectedCompany
End Sub

Private Sub mnuLogout_Click()
    cn.Close
    End
End Sub


Private Sub mnuManageUsers_Click()
     frmSelectCustomer.SelectUser
     If SelectedCompany = 0 Then Exit Sub
     frmManageUsers.ManageUser SelectedCompany
End Sub

Private Sub mnuNewCustomer_Click()
    frmAddCustomer.AddCompany
End Sub

Private Sub mnuNewOrder_Click()
    frmNewOrder.Show
End Sub

Private Sub mnuPaymentReceived_Click()
    frmSelectCustomer.SelectCompany
    If SelectedCompany = 0 Then Exit Sub
    frmCustomerOrders.PaymentReceived SelectedCompany
End Sub

Private Sub mnuProductAdmin_Click()
    MsgBox "Not Implemented", vbInformation
End Sub

Private Sub mnuSearchOrders_Click()
    mnuCustomerOrders_Click
End Sub

Private Sub mnuUpdateCustomerAccount_Click()
    frmSelectCustomer.SelectCompany
    If SelectedCompany = 0 Then Exit Sub
    frmAddCustomer.ViewBalance SelectedCompany
End Sub
