VERSION 5.00
Begin VB.Form frmNewOrder 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "New Order"
   ClientHeight    =   2400
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6405
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   2400
   ScaleWidth      =   6405
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel Order"
      Height          =   375
      Left            =   5040
      TabIndex        =   13
      Top             =   1980
      Width           =   1275
   End
   Begin VB.CommandButton cmdCommitOrder 
      Caption         =   "Commit Order"
      Height          =   375
      Left            =   3420
      TabIndex        =   12
      Top             =   1980
      Width           =   1455
   End
   Begin VB.TextBox txtTotal 
      BackColor       =   &H80000000&
      Height          =   315
      Left            =   1020
      Locked          =   -1  'True
      TabIndex        =   11
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton cmdCalculate 
      Caption         =   "Calculate"
      Height          =   375
      Left            =   4080
      TabIndex        =   9
      Top             =   960
      Width           =   2235
   End
   Begin VB.TextBox txtPrice 
      BackColor       =   &H80000000&
      Height          =   315
      Left            =   5100
      Locked          =   -1  'True
      TabIndex        =   8
      Top             =   540
      Width           =   1215
   End
   Begin VB.TextBox txtQty 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   1080
      MaxLength       =   3
      TabIndex        =   6
      Text            =   "1"
      Top             =   960
      Width           =   495
   End
   Begin VB.ComboBox cboProduct 
      Height          =   315
      Left            =   1080
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   540
      Width           =   2895
   End
   Begin VB.CommandButton cmdNewCustomer 
      Caption         =   "New Customer"
      Height          =   315
      Left            =   5040
      TabIndex        =   2
      Top             =   120
      Width           =   1275
   End
   Begin VB.ComboBox cboCustomer 
      Height          =   315
      Left            =   1080
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   120
      Width           =   3795
   End
   Begin VB.Label Label1 
      Caption         =   "Order Total"
      Height          =   315
      Index           =   4
      Left            =   60
      TabIndex        =   10
      Top             =   1500
      Width           =   855
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   6360
      Y1              =   1380
      Y2              =   1380
   End
   Begin VB.Label Label1 
      Caption         =   "Price Each"
      Height          =   315
      Index           =   3
      Left            =   4080
      TabIndex        =   7
      Top             =   540
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Quantity"
      Height          =   315
      Index           =   2
      Left            =   60
      TabIndex        =   5
      Top             =   1020
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Product ID"
      Height          =   315
      Index           =   1
      Left            =   60
      TabIndex        =   3
      Top             =   600
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Customer ID"
      Height          =   315
      Index           =   0
      Left            =   60
      TabIndex        =   0
      Top             =   180
      Width           =   975
   End
End
Attribute VB_Name = "frmNewOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim rs As New Recordset

Dim cust As New Collection
Dim prod As New Collection

'sql injection in txtQty after Calculate
'sqlinjection in txtTotal if unlocked


Private Sub cboProduct_Click()
    txtPrice = prod(cboProduct.Text)
End Sub

Private Sub cmdCalculate_Click()
    
    If Len(txtPrice) = 0 Then
        MsgBox "Select an item first", vbInformation
        Exit Sub
    End If
    
    If Len(cboCustomer.Text) = 0 Then
        MsgBox "Select a customer first", vbInformation
        Exit Sub
    End If
    
    If Not IsNumeric(txtQty) Or CInt(txtQty) < 1 Then
        MsgBox "Invalid Quantity", vbInformation
        Exit Sub
    End If
    
    txtTotal = txtPrice * txtQty
    
    
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdCommitOrder_Click()
    
    If txtTotal = Empty Then
        MsgBox "Calculate Total First", vbInformation
        Exit Sub
    End If
    
    Dim custId As Long
    custId = cust(cboCustomer.Text)
    
    cn.Execute "Insert into tblOrders (customer,productNumber,quantity,ordertotal) " & _
               "Values(" & custId & "," & (cboProduct.ListIndex + 1) & "," & _
               txtQty & "," & txtTotal & ")"
            

    rs.Open "Select * from tblCustomers where autoid=" & cust(cboCustomer.Text)
    
    Dim balance As Long
    balance = rs!balanceDue + txtTotal
    
    rs.Close
    cn.Execute "Update tblcustomers set balancedue=" & balance & " where autoid=" & custId
    
    Unload Me
    
End Sub

Private Sub cmdNewCustomer_Click()
    frmAddCustomer.AddCompany
    LoadCustomers
End Sub

Private Sub Form_Load()
    
    rs.ActiveConnection = cn
    
    LoadCustomers
    
    rs.Open "Select * from tblProducts"
    
    With cboProduct
        While Not rs.EOF
            .AddItem rs!ProductName
            prod.Add CStr(rs!price), CStr(rs!ProductName)
            rs.MoveNext
        Wend
    End With
        
    rs.Close
    
End Sub

Sub LoadCustomers()
    rs.Open "Select * from tblCustomers"
    
    Set cust = Nothing
    Set cust = New Collection
    
    With cboCustomer
        .Clear
        
        While Not rs.EOF
            .AddItem rs("company")
            cust.Add CStr(rs!autoid), CStr(rs!company)
            rs.MoveNext
        Wend
        
    End With
        
    rs.Close
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set prod = Nothing
    Set cust = Nothing
End Sub
