VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmSelectCustomer 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Customer List"
   ClientHeight    =   3675
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6570
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3675
   ScaleWidth      =   6570
   StartUpPosition =   2  'CenterScreen
   Begin VB.OptionButton Option1 
      Caption         =   "Paid Orders"
      Height          =   255
      Index           =   1
      Left            =   1740
      TabIndex        =   3
      Top             =   3300
      Visible         =   0   'False
      Width           =   1395
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Unpaid Orders"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   3300
      Value           =   -1  'True
      Visible         =   0   'False
      Width           =   1455
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   "Select"
      Height          =   375
      Left            =   5280
      TabIndex        =   1
      Top             =   3240
      Width           =   1215
   End
   Begin MSComctlLib.ListView lv 
      Height          =   3195
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6555
      _ExtentX        =   11562
      _ExtentY        =   5636
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   1
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Customer Name"
         Object.Width           =   2540
      EndProperty
   End
End
Attribute VB_Name = "frmSelectCustomer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim rs As New Recordset
Dim myCustId As Long

'Dim myRole As selectionroles
'
'Private Enum selectionroles
'    companySelector = 0
'    orderSelector = 1
'    userSelector = 2
'End Enum

Private Sub Form_Load()
    SelectedCompany = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set rs = Nothing
End Sub


Private Sub cmdSelect_Click()
    
    If lv.SelectedItem Is Nothing Then
        MsgBox "You must first select an item"
        Exit Sub
    End If
    
    SelectedCompany = CLng(lv.SelectedItem.Tag)
    
    Unload Me
    
End Sub

Sub SelectCompany()
    
    Dim li As ListItem
    
    rs.ActiveConnection = cn
    rs.Open "Select autoid,company from tblcustomers"
    
    While Not rs.EOF
        Set li = lv.ListItems.Add(, , rs!company)
        li.Tag = rs!autoid
        rs.MoveNext
    Wend
    
    rs.Close
    
    lv.ColumnHeaders(1).Width = lv.Width - 120
    
    Me.Show 1
End Sub

Sub SelectUser()
    
    Dim li As ListItem
    Dim g  As UserGroups
    
    'myRole = userSelector
    
    rs.ActiveConnection = cn
    rs.Open "Select * from tblusers"
    
    lv.ColumnHeaders.Clear
    lv.ColumnHeaders.Add , , "UserName"
    lv.ColumnHeaders.Add , , "UserGroup"
     
    
    While Not rs.EOF
        Set li = lv.ListItems.Add(, , rs!username)
        li.Tag = rs!autoid
        g = rs!Group
        Select Case g
            Case DataEntry: li.SubItems(1) = "DataEntry"
            Case Accounting: li.SubItems(1) = "Accounting"
            Case Administrator: li.SubItems(1) = "Administrator"
        End Select
        rs.MoveNext
    Wend
    
    rs.Close
    
    lv.ColumnHeaders(2).Width = lv.Width - lv.ColumnHeaders(2).Left
    
    Me.Show 1
    
End Sub


Sub ShowOrders(ByVal custId As Long, Optional isPaid = 0)
    
    myCustId = custId
    Me.Caption = "Orders by Customer"
    
    rs.ActiveConnection = cn
    rs.Open "Select * from tblOrders where customer=" & custId & " and ispaid=" & isPaid
    
    Option1(0).Visible = True
    Option1(1).Visible = True
    
    lv.ListItems.Clear
    lv.ColumnHeaders.Clear
    
    If rs.EOF And rs.BOF Then
        lv.ColumnHeaders.Add , , "message"
        lv.ListItems.Add , , "There are no Current " & IIf(isPaid = 0, "Unpaid", "Completed") & " Orders for this company"
        Exit Sub
    End If
    
    lv.ColumnHeaders.Clear
    lv.ColumnHeaders.Add , , "Order ID"
    lv.ColumnHeaders.Add , , "Product"
    lv.ColumnHeaders.Add , , "Qty"
    lv.ColumnHeaders.Add , , "Total"
    
    lv.ColumnHeaders(4).Width = Me.Width - lv.ColumnHeaders(4).Left - 120

    Dim li As ListItem
    
    While Not rs.EOF
        Set li = lv.ListItems.Add()
        li.Text = rs!autoid
        li.SubItems(1) = productsByID("id:" & rs!productNumber)
        li.SubItems(2) = rs!quantity
        li.SubItems(3) = rs!ordertotal
        rs.MoveNext
    Wend
        
    rs.Close
    cmdSelect.Visible = False
    Me.Show
    
End Sub


Private Sub Option1_Click(Index As Integer)
    ShowOrders myCustId, Index
End Sub



